diff -ruN vdr-1.3.37/menu.h vdr-1.3.38/menu.h
--- vdr-1.3.37/menu.h	2005-11-05 18:26:09.000000000 +0100
+++ vdr-1.3.38/menu.h	2006-01-06 12:30:38.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.h 1.77 2005/11/05 17:26:09 kls Exp $
+ * $Id: menu.h 1.81 2006/01/06 11:30:38 kls Exp $
  */
 
 #ifndef __MENU_H
@@ -55,11 +55,18 @@
 
 class cMenuMain : public cOsdMenu {
 private:
+  time_t lastDiskSpaceCheck;
+  int lastFreeMB;
   bool replaying;
+  cOsdItem *stopReplayItem;
+  cOsdItem *cancelEditingItem;
+  cOsdItem *stopRecordingItem;
+  int recordControlsState;
   static cOsdObject *pluginOsdObject;
   void Set(void);
+  bool Update(bool Force = false);
 public:
-  cMenuMain(bool Replaying, eOSState State = osUnknown);
+  cMenuMain(eOSState State = osUnknown);
   virtual eOSState ProcessKey(eKeys Key);
   static cOsdObject *PluginOsdObject(void);
   };
@@ -71,6 +78,7 @@
   bool withInfo;
   cTimeMs lastTime;
   int number;
+  bool timeout;
   cChannel *channel;
   const cEvent *lastPresent;
   const cEvent *lastFollowing;
@@ -189,11 +197,11 @@
 class cRecordControls {
 private:
   static cRecordControl *RecordControls[];
+  static int state;
 public:
   static bool Start(cTimer *Timer = NULL, bool Pause = false);
   static void Stop(const char *InstantId);
   static void Stop(cDevice *Device);
-  static bool StopPrimary(bool DoIt = false);
   static bool PauseLiveVideo(void);
   static const char *GetInstantId(const char *LastInstantId);
   static cRecordControl *GetRecordControl(const char *FileName);
@@ -201,6 +209,8 @@
   static void ChannelDataModified(cChannel *Channel);
   static bool Active(void);
   static void Shutdown(void);
+  static void ChangeState(void) { state++; }
+  static bool StateChanged(int &State);
   };
 
 class cReplayControl : public cDvbPlayerControl {
@@ -230,6 +240,7 @@
 public:
   cReplayControl(void);
   virtual ~cReplayControl();
+  virtual cOsdObject *GetInfo(void);
   virtual eOSState ProcessKey(eKeys Key);
   virtual void Show(void);
   virtual void Hide(void);
diff -ruN vdr-1.3.37/menuitems.c vdr-1.3.38/menuitems.c
--- vdr-1.3.37/menuitems.c	2005-11-12 13:22:10.000000000 +0100
+++ vdr-1.3.38/menuitems.c	2006-01-07 16:37:03.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.c 1.24 2005/11/12 12:22:10 kls Exp $
+ * $Id: menuitems.c 1.29 2006/01/07 15:37:03 kls Exp $
  */
 
 #include "menuitems.h"
@@ -15,7 +15,7 @@
 #include "skins.h"
 #include "status.h"
 
-const char *FileNameChars = " abcdefghijklmnopqrstuvwxyz0123456789-.#~";
+const char *FileNameChars = " abcdefghijklmnopqrstuvwxyz0123456789-.#~,/_@";
 
 // --- cMenuEditItem ---------------------------------------------------------
 
@@ -116,7 +116,7 @@
 
 // --- cMenuEditBitItem ------------------------------------------------------
 
-cMenuEditBitItem::cMenuEditBitItem(const char *Name, int *Value, int Mask, const char *FalseString, const char *TrueString)
+cMenuEditBitItem::cMenuEditBitItem(const char *Name, uint *Value, uint Mask, const char *FalseString, const char *TrueString)
 :cMenuEditBoolItem(Name, &bit, FalseString, TrueString)
 {
   value = Value;
@@ -243,6 +243,9 @@
   pos = -1;
   insert = uppercase = false;
   newchar = true;
+  charMap = tr(" 0\t-.#~,/_@1\tabc2\tdef3\tghi4\tjkl5\tmno6\tpqrs7\ttuv8\twxyz9");
+  currentChar = NULL;
+  lastKey = kNone;
   Set();
 }
 
@@ -253,8 +256,8 @@
 
 void cMenuEditStrItem::SetHelpKeys(void)
 {
-  if (pos >= 0)
-     cSkinDisplay::Current()->SetButtons(tr("ABC/abc"), tr(insert ? "Overwrite" : "Insert"), tr("Delete"));
+  if (InEditMode())
+     cSkinDisplay::Current()->SetButtons(tr("Button$ABC/abc"), tr(insert ? "Button$Overwrite" : "Button$Insert"), tr("Button$Delete"));
   else
      cSkinDisplay::Current()->SetButtons(NULL);
 }
@@ -264,7 +267,7 @@
   char buf[1000];
   const char *fmt = insert && newchar ? "[]%c%s" : "[%c]%s";
 
-  if (pos >= 0) {
+  if (InEditMode()) {
      const cFont *font = cFont::GetFont(fontOsd);
      strncpy(buf, value, pos);
      snprintf(buf + pos, sizeof(buf) - pos - 2, fmt, *(value + pos), value + pos + 1);
@@ -320,9 +323,12 @@
 
 eOSState cMenuEditStrItem::ProcessKey(eKeys Key)
 {
+  bool SameKey = Key == lastKey;
+  if (Key != kNone)
+     lastKey = Key;
   switch (Key) {
     case kRed:   // Switch between upper- and lowercase characters
-                 if (pos >= 0) {
+                 if (InEditMode()) {
                     if (!insert || !newchar) {
                        uppercase = !uppercase;
                        value[pos] = uppercase ? toupper(value[pos]) : tolower(value[pos]);
@@ -332,7 +338,7 @@
                     return osUnknown;
                  break;
     case kGreen: // Toggle insert/overwrite modes
-                 if (pos >= 0) {
+                 if (InEditMode()) {
                     insert = !insert;
                     newchar = true;
                     SetHelpKeys();
@@ -342,7 +348,7 @@
                  break;
     case kYellow|k_Repeat:
     case kYellow: // Remove the character at current position; in insert mode it is the character to the right of cursor
-                 if (pos >= 0) {
+                 if (InEditMode()) {
                     if (strlen(value) > 1) {
                        if (!insert || pos < int(strlen(value)) - 1)
                           memmove(value + pos, value + pos + 1, strlen(value) - pos);
@@ -361,7 +367,7 @@
                  break;
     case kBlue|k_Repeat:
     case kBlue:  // consume the key only if in edit-mode
-                 if (pos >= 0)
+                 if (InEditMode())
                     ;
                  else
                     return osUnknown;
@@ -395,7 +401,7 @@
     case kUp|k_Repeat:
     case kUp:
     case kDown|k_Repeat:
-    case kDown:  if (pos >= 0) {
+    case kDown:  if (InEditMode()) {
                     if (insert && newchar) {
                        // create a new character in insert mode
                        if (int(strlen(value)) < length - 1) {
@@ -412,7 +418,39 @@
                  else
                     return cMenuEditItem::ProcessKey(Key);
                  break;
-    case kOk:    if (pos >= 0) {
+    case k0 ... k9: {
+                 if (!SameKey)
+                    currentChar = NULL;
+                 if (InEditMode()) {
+                    if (insert && newchar) {
+                       // create a new character in insert mode
+                       if (int(strlen(value)) < length - 1) {
+                          memmove(value + pos + 1, value + pos, strlen(value) - pos + 1);
+                          value[pos] = ' ';
+                          }
+                       }
+                    if (!currentChar || !*currentChar || *currentChar == '\t') {
+                       // find the beginning of the character map entry for Key
+                       int n = Key - k0;
+                       currentChar = charMap;
+                       while (n > 0 && *currentChar) {
+                             if (*currentChar++ == '\t')
+                                n--;
+                             }
+                       }
+                    if (*currentChar && *currentChar != '\t') {
+                       value[pos] = *currentChar;
+                       if (uppercase)
+                          value[pos] = toupper(value[pos]);
+                       currentChar++;
+                       }
+                    newchar = false;
+                    }
+                 else
+                    return cMenuEditItem::ProcessKey(Key);
+                 }
+                 break;
+    case kOk:    if (InEditMode()) {
                     pos = -1;
                     newchar = true;
                     stripspace(value);
@@ -420,7 +458,7 @@
                     break;
                     }
                  // run into default
-    default:     if (pos >= 0 && BASICKEY(Key) == kKbd) {
+    default:     if (InEditMode() && BASICKEY(Key) == kKbd) {
                     int c = KEYKBD(Key);
                     if (c <= 0xFF) {
                        const char *p = strchr(allowed, tolower(c));
@@ -667,6 +705,7 @@
               }
            else {
               *weekdays = days[cTimer::GetWDay(*value)];
+              dayindex = FindDayIndex(*weekdays);
               oldvalue = *value;
               *value = 0;
               }
diff -ruN vdr-1.3.37/menuitems.h vdr-1.3.38/menuitems.h
--- vdr-1.3.37/menuitems.h	2005-11-11 14:26:51.000000000 +0100
+++ vdr-1.3.38/menuitems.h	2006-01-06 16:16:25.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.h 1.12 2005/11/11 13:26:51 kls Exp $
+ * $Id: menuitems.h 1.15 2006/01/06 15:16:25 kls Exp $
  */
 
 #ifndef __MENUITEMS_H
@@ -44,12 +44,12 @@
 
 class cMenuEditBitItem : public cMenuEditBoolItem {
 protected:
-  int *value;
+  uint *value;
+  uint mask;
   int bit;
-  int mask;
   virtual void Set(void);
 public:
-  cMenuEditBitItem(const char *Name, int *Value, int Mask, const char *FalseString = NULL, const char *TrueString = NULL);
+  cMenuEditBitItem(const char *Name, uint *Value, uint Mask, const char *FalseString = NULL, const char *TrueString = NULL);
   };
 
 class cMenuEditNumItem : public cMenuEditItem {
@@ -82,9 +82,14 @@
   char *allowed;
   int pos;
   bool insert, newchar, uppercase;
+  const char *charMap;
+  const char *currentChar;
+  eKeys lastKey;
   void SetHelpKeys(void);
   virtual void Set(void);
   char Inc(char c, bool Up);
+protected:
+  bool InEditMode(void) { return pos >= 0; }
 public:
   cMenuEditStrItem(const char *Name, char *Value, int Length, const char *Allowed);
   ~cMenuEditStrItem();
diff -ruN vdr-1.3.37/osd.c vdr-1.3.38/osd.c
--- vdr-1.3.37/osd.c	2005-11-04 15:19:31.000000000 +0100
+++ vdr-1.3.38/osd.c	2005-12-30 16:42:04.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.c 1.64 2005/11/04 14:19:31 kls Exp $
+ * $Id: osd.c 1.65 2005/12/30 15:42:04 kls Exp $
  */
 
 #include "osd.h"
@@ -145,7 +145,7 @@
         esyslog("ERROR: can't allocate bitmap!");
      }
   else
-     esyslog("ERROR: illegal bitmap parameters (%d, %d)!", width, height);
+     esyslog("ERROR: invalid bitmap parameters (%d, %d)!", width, height);
 }
 
 bool cBitmap::Contains(int x, int y) const
diff -ruN vdr-1.3.37/osd.h vdr-1.3.38/osd.h
--- vdr-1.3.37/osd.h	2005-06-19 12:35:25.000000000 +0200
+++ vdr-1.3.38/osd.h	2005-12-18 13:56:21.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.h 1.49 2005/06/19 10:35:25 kls Exp $
+ * $Id: osd.h 1.50 2005/12/18 12:56:21 kls Exp $
  */
 
 #ifndef __OSD_H
@@ -37,6 +37,7 @@
                  oeAreasOverlap,
                  oeWrongAlignment,
                  oeOutOfMemory,
+                 oeWrongAreaSize,
                  oeUnknown,
                };
 
diff -ruN vdr-1.3.37/osdbase.c vdr-1.3.38/osdbase.c
--- vdr-1.3.37/osdbase.c	2005-10-09 12:56:26.000000000 +0200
+++ vdr-1.3.38/osdbase.c	2006-01-08 12:40:02.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osdbase.c 1.24 2005/10/09 10:56:26 kls Exp $
+ * $Id: osdbase.c 1.28 2006/01/08 11:40:02 kls Exp $
  */
 
 #include "osdbase.h"
@@ -19,7 +19,6 @@
 cOsdItem::cOsdItem(eOSState State)
 {
   text = NULL;
-  offset = -1;
   state = State;
   selectable = true;
   fresh = true;
@@ -28,7 +27,6 @@
 cOsdItem::cOsdItem(const char *Text, eOSState State, bool Selectable)
 {
   text = NULL;
-  offset = -1;
   state = State;
   selectable = Selectable;
   fresh = true;
@@ -61,6 +59,14 @@
   return Key == kOk ? state : osUnknown;
 }
 
+// --- cOsdObject ------------------------------------------------------------
+
+void cOsdObject::Show(void)
+{
+  if (isMenu)
+     ((cOsdMenu *)this)->Display();
+}
+
 // --- cOsdMenu --------------------------------------------------------------
 
 cSkinDisplayMenu *cOsdMenu::displayMenu = NULL;
@@ -155,10 +161,10 @@
 {
   cList<cOsdItem>::Del(Get(Index));
   int count = Count();
-  while (current < count && !SelectableItem(current)) 
+  while (current < count && !SelectableItem(current))
         current++;
   if (current == count) {
-     while (current > 0 && !SelectableItem(current))  
+     while (current > 0 && !SelectableItem(current))
            current--;
      }
   if (Index == first && first > 0)
@@ -252,6 +258,8 @@
 
 void cOsdMenu::Clear(void)
 {
+  if (marked >= 0)
+     SetStatus(NULL);
   first = 0;
   current = marked = -1;
   cList<cOsdItem>::Clear();
@@ -363,7 +371,7 @@
      CursorUp();
 }
 
-void cOsdMenu::PageDown(void) 
+void cOsdMenu::PageDown(void)
 {
   int oldCurrent = current;
   int oldFirst = first;
@@ -455,6 +463,7 @@
         }
      }
   switch (Key) {
+    case k0:      return osUnknown;
     case k1...k9: return hasHotkeys ? HotKey(Key) : osUnknown;
     case kUp|k_Repeat:
     case kUp:   CursorUp();   break;
diff -ruN vdr-1.3.37/osdbase.h vdr-1.3.38/osdbase.h
--- vdr-1.3.37/osdbase.h	2005-10-02 11:18:20.000000000 +0200
+++ vdr-1.3.38/osdbase.h	2006-01-06 12:55:30.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osdbase.h 1.12 2005/10/02 09:18:20 kls Exp $
+ * $Id: osdbase.h 1.14 2006/01/06 11:55:30 kls Exp $
  */
 
 #ifndef __OSDBASE_H
@@ -49,7 +49,6 @@
 class cOsdItem : public cListObject {
 private:
   char *text;
-  int offset;
   eOSState state;
   bool selectable;
 protected:
@@ -78,7 +77,7 @@
   virtual ~cOsdObject() {}
   bool NeedsFastResponse(void) { return needsFastResponse; }
   bool IsMenu(void) { return isMenu; }
-  virtual void Show(void) {}
+  virtual void Show(void);
   virtual eOSState ProcessKey(eKeys Key) { return osUnknown; }
   };
 
diff -ruN vdr-1.3.37/player.c vdr-1.3.38/player.c
--- vdr-1.3.37/player.c	2004-12-12 12:21:07.000000000 +0100
+++ vdr-1.3.38/player.c	2006-01-06 12:30:07.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: player.c 1.9 2004/12/12 11:21:07 kls Exp $
+ * $Id: player.c 1.11 2006/01/06 11:30:07 kls Exp $
  */
 
 #include "player.h"
@@ -40,6 +40,7 @@
 // --- cControl --------------------------------------------------------------
 
 cControl *cControl::control = NULL;
+cMutex cControl::mutex;
 
 cControl::cControl(cPlayer *Player, bool Hidden)
 {
@@ -54,19 +55,27 @@
      control = NULL;
 }
 
+cOsdObject *cControl::GetInfo(void)
+{
+  return NULL;
+}
+
 cControl *cControl::Control(void)
 {
+  cMutexLock MutexLock(&mutex);
   return (control && !control->hidden) ? control : NULL;
 }
 
 void cControl::Launch(cControl *Control)
 {
+  cMutexLock MutexLock(&mutex);
   delete control;
   control = Control;
 }
 
 void cControl::Attach(void)
 {
+  cMutexLock MutexLock(&mutex);
   if (control && !control->attached && control->player && !control->player->IsAttached()) {
      if (cDevice::PrimaryDevice()->AttachPlayer(control->player))
         control->attached = true;
@@ -79,6 +88,7 @@
 
 void cControl::Shutdown(void)
 {
+  cMutexLock MutexLock(&mutex);
   cControl *c = control; // avoids recursions
   control = NULL;
   delete c;
diff -ruN vdr-1.3.37/player.h vdr-1.3.38/player.h
--- vdr-1.3.37/player.h	2005-05-22 13:07:42.000000000 +0200
+++ vdr-1.3.38/player.h	2006-01-06 12:29:27.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: player.h 1.17 2005/05/22 11:07:42 kls Exp $
+ * $Id: player.h 1.19 2006/01/06 11:29:27 kls Exp $
  */
 
 #ifndef __PLAYER_H
@@ -62,6 +62,7 @@
 class cControl : public cOsdObject {
 private:
   static cControl *control;
+  static cMutex mutex;
   bool attached;
   bool hidden;
 protected:
@@ -70,6 +71,7 @@
   cControl(cPlayer *Player, bool Hidden = false);
   virtual ~cControl();
   virtual void Hide(void) = 0;
+  virtual cOsdObject *GetInfo(void);
   bool GetIndex(int &Current, int &Total, bool SnapToIFrame = false) { return player->GetIndex(Current, Total, SnapToIFrame); }
   bool GetReplayMode(bool &Play, bool &Forward, int &Speed) { return player->GetReplayMode(Play, Forward, Speed); }
   static void Launch(cControl *Control);
diff -ruN vdr-1.3.37/plugin.c vdr-1.3.38/plugin.c
--- vdr-1.3.37/plugin.c	2005-08-27 18:13:24.000000000 +0200
+++ vdr-1.3.38/plugin.c	2006-01-08 12:40:05.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: plugin.c 1.15 2005/08/27 16:13:24 kls Exp $
+ * $Id: plugin.c 1.16 2006/01/08 11:40:05 kls Exp $
  */
 
 #include "plugin.h"
@@ -25,7 +25,7 @@
 
 char *cPlugin::configDirectory = NULL;
 
-cPlugin::cPlugin(void) 
+cPlugin::cPlugin(void)
 {
   name = NULL;
   started = false;
diff -ruN vdr-1.3.37/rcu.c vdr-1.3.38/rcu.c
--- vdr-1.3.37/rcu.c	2005-08-15 14:30:21.000000000 +0200
+++ vdr-1.3.38/rcu.c	2006-01-08 12:40:09.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: rcu.c 1.10 2005/08/15 12:30:21 kls Exp $
+ * $Id: rcu.c 1.13 2006/01/08 11:40:09 kls Exp $
  */
 
 #include "rcu.h"
@@ -23,8 +23,8 @@
   dp = 0;
   mode = modeB;
   code = 0;
-  numberToSend = -1;
-  lastNumber = 0;
+  number = 0;
+  data = 0;
   receivedCommand = false;
   if ((f = open(DeviceName, O_RDWR | O_NONBLOCK)) >= 0) {
      struct termios t;
@@ -32,7 +32,7 @@
         cfsetspeed(&t, B9600);
         cfmakeraw(&t);
         if (tcsetattr(f, TCSAFLUSH, &t) == 0) {
-           Number(0);//XXX 8888???
+           SetNumber(8888);
            const char *Setup = GetSetup();
            if (Setup) {
               code = *Setup;
@@ -95,13 +95,12 @@
 
   time_t LastCodeRefresh = 0;
   cTimeMs FirstTime;
+  unsigned char LastCode = 0, LastMode = 0;
   uint64 LastCommand = 0;
+  unsigned int LastData = 0;
   bool repeat = false;
 
   while (Running() && f >= 0) {
-
-        LOCK_THREAD;
-
         if (ReceiveByte(REPEATLIMIT) == 'X') {
            for (int i = 0; i < 6; i++) {
                int b = ReceiveByte();
@@ -140,11 +139,22 @@
            LastCommand = 0;
            }
         else {
-           LastCommand = 0;
-           if (numberToSend >= 0) {
-              Number(numberToSend);
-              numberToSend = -1;
+           unsigned int d = data;
+           if (d != LastData) {
+              SendData(d);
+              LastData = d;
               }
+           unsigned char c = code;
+           if (c != LastCode) {
+              SendCommand(c);
+              LastCode = c;
+              }
+           unsigned char m = mode;
+           if (m != LastMode) {
+              SendCommand(m);
+              LastMode = m;
+              }
+           LastCommand = 0;
            }
         if (code && time(NULL) - LastCodeRefresh > 60) {
            SendCommand(code); // in case the PIC listens to the wrong code
@@ -192,8 +202,6 @@
 
 bool cRcuRemote::SendByte(unsigned char c)
 {
-  LOCK_THREAD;
-
   for (int retry = 5; retry--;) {
       if (SendByteHandshake(c))
          return true;
@@ -201,32 +209,34 @@
   return false;
 }
 
-bool cRcuRemote::SetCode(unsigned char Code)
+bool cRcuRemote::SendData(unsigned int n)
+{
+  for (int i = 0; i < 4; i++) {
+      if (!SendByte(n & 0x7F))
+         return false;
+      n >>= 8;
+      }
+  return SendCommand(mode);
+}
+
+void cRcuRemote::SetCode(unsigned char Code)
 {
   code = Code;
-  return SendCommand(code);
 }
 
-bool cRcuRemote::SetMode(unsigned char Mode)
+void cRcuRemote::SetMode(unsigned char Mode)
 {
   mode = Mode;
-  return SendCommand(mode);
 }
 
 bool cRcuRemote::SendCommand(unsigned char Cmd)
-{ 
+{
   return SendByte(Cmd | 0x80);
 }
 
-bool cRcuRemote::Digit(int n, int v)
-{ 
-  return SendByte(((n & 0x03) << 5) | (v & 0x0F) | (((dp >> n) & 0x01) << 4));
-}
-
-bool cRcuRemote::Number(int n, bool Hex)
+void cRcuRemote::SetNumber(int n, bool Hex)
 {
-  LOCK_THREAD;
-
+  number = n;
   if (!Hex) {
      char buf[8];
      sprintf(buf, "%4d", n & 0xFFFF);
@@ -237,19 +247,17 @@
          n = (n << 4) | ((*d - '0') & 0x0F);
          }
      }
-  lastNumber = n;
+  unsigned int m = 0;
   for (int i = 0; i < 4; i++) {
-      if (!Digit(i, n))
-         return false;
+      m <<= 8;
+      m |= ((i & 0x03) << 5) | (n & 0x0F) | (((dp >> i) & 0x01) << 4);
       n >>= 4;
       }
-  return SendCommand(mode);
+  data = m;
 }
 
-bool cRcuRemote::String(char *s)
+void cRcuRemote::SetString(char *s)
 {
-  LOCK_THREAD;
-
   const char *chars = mode == modeH ? "0123456789ABCDEF" : "0123456789-EHLP ";
   int n = 0;
 
@@ -262,16 +270,16 @@
              }
           }
       }
-  return Number(n, true);
+  SetNumber(n, true);
 }
 
 void cRcuRemote::SetPoints(unsigned char Dp, bool On)
-{ 
+{
   if (On)
      dp |= Dp;
   else
      dp &= ~Dp;
-  Number(lastNumber, true);
+  SetNumber(number);
 }
 
 bool cRcuRemote::DetectCode(unsigned char *Code)
@@ -291,12 +299,12 @@
      SetMode(modeH);
      char buf[5];
      sprintf(buf, "C0D%c", *Code);
-     String(buf);
+     SetString(buf);
      SetCode(*Code);
      cCondWait::SleepMs(2 * REPEATDELAY);
      if (receivedCommand) {
         SetMode(modeB);
-        String("----");
+        SetString("----");
         return true;
         }
      if (*Code < 'D') {
@@ -310,13 +318,11 @@
 
 void cRcuRemote::ChannelSwitch(const cDevice *Device, int ChannelNumber)
 {
-  if (ChannelNumber && Device->IsPrimaryDevice()) {
-     LOCK_THREAD;
-     numberToSend = cDevice::CurrentChannel();
-     }
+  if (ChannelNumber && Device->IsPrimaryDevice())
+     SetNumber(cDevice::CurrentChannel());
 }
 
-void cRcuRemote::Recording(const cDevice *Device, const char *Name)
+void cRcuRemote::Recording(const cDevice *Device, const char *Name, const char *FileName, bool On)
 {
   SetPoints(1 << Device->DeviceNumber(), Device->Receiving());
 }
diff -ruN vdr-1.3.37/rcu.h vdr-1.3.38/rcu.h
--- vdr-1.3.37/rcu.h	2005-07-31 12:18:00.000000000 +0200
+++ vdr-1.3.38/rcu.h	2005-12-31 16:09:25.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: rcu.h 1.4 2005/07/31 10:18:00 kls Exp $
+ * $Id: rcu.h 1.6 2005/12/31 15:09:25 kls Exp $
  */
 
 #ifndef __RCU_H
@@ -19,23 +19,23 @@
   enum { modeH = 'h', modeB = 'b', modeS = 's' };
   int f;
   unsigned char dp, code, mode;
-  int numberToSend;
-  int lastNumber;
+  int number;
+  unsigned int data;
   bool receivedCommand;
   bool SendCommand(unsigned char Cmd);
   int ReceiveByte(int TimeoutMs = 0);
   bool SendByteHandshake(unsigned char c);
   bool SendByte(unsigned char c);
-  bool Digit(int n, int v);
-  bool SetCode(unsigned char Code);
-  bool SetMode(unsigned char Mode);
-  bool Number(int n, bool Hex = false);
+  bool SendData(unsigned int n);
+  void SetCode(unsigned char Code);
+  void SetMode(unsigned char Mode);
+  void SetNumber(int n, bool Hex = false);
   void SetPoints(unsigned char Dp, bool On);
-  bool String(char *s);
+  void SetString(char *s);
   bool DetectCode(unsigned char *Code);
   virtual void Action(void);
   virtual void ChannelSwitch(const cDevice *Device, int ChannelNumber);
-  virtual void Recording(const cDevice *Device, const char *Name);
+  virtual void Recording(const cDevice *Device, const char *Name, const char *FileName, bool On);
 public:
   cRcuRemote(const char *DeviceName);
   virtual ~cRcuRemote();
diff -ruN vdr-1.3.37/recorder.c vdr-1.3.38/recorder.c
--- vdr-1.3.37/recorder.c	2005-10-31 13:35:29.000000000 +0100
+++ vdr-1.3.38/recorder.c	2006-01-08 12:01:25.000000000 +0100
@@ -4,13 +4,13 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recorder.c 1.16 2005/10/31 12:35:29 kls Exp $
+ * $Id: recorder.c 1.17 2006/01/08 11:01:25 kls Exp $
  */
 
+#include "recorder.h"
 #include <stdarg.h>
 #include <stdio.h>
 #include <unistd.h>
-#include "recorder.h"
 
 #define RECORDERBUFSIZE  MEGABYTE(5)
 
@@ -171,6 +171,8 @@
            int Count = remux->Put(b, r);
            if (Count)
               ringBuffer->Del(Count);
+           else
+              cCondWait::SleepMs(100); // avoid busy loop when resultBuffer is full in cRemux::Put()
            }
         }
 }
diff -ruN vdr-1.3.37/recording.c vdr-1.3.38/recording.c
--- vdr-1.3.37/recording.c	2005-11-04 15:19:44.000000000 +0100
+++ vdr-1.3.38/recording.c	2006-01-08 12:40:13.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 1.124 2005/11/04 14:19:44 kls Exp $
+ * $Id: recording.c 1.132 2006/01/08 11:40:13 kls Exp $
  */
 
 #include "recording.h"
@@ -48,8 +48,8 @@
 
 #define MINDISKSPACE 1024 // MB
 
-#define DELETEDLIFETIME     1 // hours after which a deleted recording will be actually removed
-#define REMOVECHECKDELTA 3600 // seconds between checks for removing deleted files
+#define REMOVECHECKDELTA   60 // seconds between checks for removing deleted files
+#define DELETEDLIFETIME   300 // seconds after which a deleted recording will be actually removed
 #define DISKCHECKDELTA    100 // seconds between checks for free disk space
 #define REMOVELATENCY      10 // seconds to wait until next check after removing a file
 
@@ -60,46 +60,67 @@
 
 bool VfatFileSystem = false;
 
-static cRecordings DeletedRecordings(true);
+cRecordings DeletedRecordings(true);
+
+// --- cRemoveDeletedRecordingsThread ----------------------------------------
+
+class cRemoveDeletedRecordingsThread : public cThread {
+protected:
+  virtual void Action(void);
+public:
+  cRemoveDeletedRecordingsThread(void);
+  };
+
+cRemoveDeletedRecordingsThread::cRemoveDeletedRecordingsThread(void)
+:cThread("remove deleted recordings")
+{
+}
+
+void cRemoveDeletedRecordingsThread::Action(void)
+{
+  // Make sure only one instance of VDR does this:
+  cLockFile LockFile(VideoDirectory);
+  if (LockFile.Lock()) {
+     cThreadLock DeletedRecordingsLock(&DeletedRecordings);
+     for (cRecording *r = DeletedRecordings.First(); r; ) {
+         if (r->deleted && time(NULL) - r->deleted > DELETEDLIFETIME) {
+            cRecording *next = DeletedRecordings.Next(r);
+            r->Remove();
+            DeletedRecordings.Del(r);
+            r = next;
+            RemoveEmptyVideoDirectories();
+            continue;
+            }
+         r = DeletedRecordings.Next(r);
+         }
+     }
+}
+
+static cRemoveDeletedRecordingsThread RemoveDeletedRecordingsThread;
+
+// ---
 
 void RemoveDeletedRecordings(void)
 {
   static time_t LastRemoveCheck = 0;
-  if (LastRemoveCheck == 0) {
-     DeletedRecordings.Update();
-     LastRemoveCheck = time(NULL) - REMOVECHECKDELTA * 9 / 10;
-     }
-  else if (time(NULL) - LastRemoveCheck > REMOVECHECKDELTA) {
-     // Make sure only one instance of VDR does this:
-     cLockFile LockFile(VideoDirectory);
-     if (!LockFile.Lock())
-        return;
-     // Remove the oldest file that has been "deleted":
-     cThreadLock DeletedRecordingsLock(&DeletedRecordings);
-     if (DeletedRecordings.Count()) {
-        cRecording *r = DeletedRecordings.First();
-        cRecording *r0 = r;
-        while (r) {
-              if (r->start < r0->start)
-                 r0 = r;
-              r = DeletedRecordings.Next(r);
-              }
-        if (r0 && time(NULL) - r0->start > DELETEDLIFETIME * 3600) {
-           r0->Remove();
-           DeletedRecordings.Del(r0);
-           RemoveEmptyVideoDirectories();
-           LastRemoveCheck += REMOVELATENCY;
-           return;
-           }
+  if (time(NULL) - LastRemoveCheck > REMOVECHECKDELTA) {
+     if (!RemoveDeletedRecordingsThread.Active()) {
+        cThreadLock DeletedRecordingsLock(&DeletedRecordings);
+        for (cRecording *r = DeletedRecordings.First(); r; r = DeletedRecordings.Next(r)) {
+            if (r->deleted && time(NULL) - r->deleted > DELETEDLIFETIME) {
+               RemoveDeletedRecordingsThread.Start();
+               break;
+               }
+            }
         }
-     else
-        DeletedRecordings.Update();
      LastRemoveCheck = time(NULL);
      }
 }
 
 void AssertFreeDiskSpace(int Priority)
 {
+  static cMutex Mutex;
+  cMutexLock MutexLock(&Mutex);
   // With every call to this function we try to actually remove
   // a file, or mark a file for removal ("delete" it), so that
   // it will get removed during the next call.
@@ -160,7 +181,7 @@
            }
         // Unable to free disk space, but there's nothing we can do about that...
         isyslog("...no old recording found, giving up");
-        Interface->Confirm(tr("Low disk space!"), 30);
+        Skins.QueueMessage(mtWarning, tr("Low disk space!"), 5, -1);
         }
      LastFreeDiskCheck = time(NULL);
      }
@@ -400,6 +421,8 @@
   sortBuffer = NULL;
   fileName = NULL;
   name = NULL;
+  fileSizeMB = -1; // unknown
+  deleted = 0;
   // set up the actual name:
   const char *Title = Event ? Event->Title() : NULL;
   const char *Subtitle = Event ? Event->ShortText() : NULL;
@@ -453,6 +476,8 @@
 cRecording::cRecording(const char *FileName)
 {
   resume = RESUME_NOT_INITIALIZED;
+  fileSizeMB = -1; // unknown
+  deleted = 0;
   titleBuffer = NULL;
   sortBuffer = NULL;
   fileName = strdup(FileName);
@@ -525,7 +550,7 @@
               // so assume the short text is missing and concatenate
               // line 1 and line 2 to be the long text:
               int len = strlen(data[1]);
-              if (len > 80) { 
+              if (len > 80) {
                  data[1] = (char *)realloc(data[1], len + 1 + strlen(data[2]) + 1);
                  strcat(data[1], "\n");
                  strcat(data[1], data[2]);
@@ -714,7 +739,7 @@
   bool result = true;
   char *NewName = strdup(FileName());
   char *ext = strrchr(NewName, '.');
-  if (strcmp(ext, RECEXT) == 0) {
+  if (ext && strcmp(ext, RECEXT) == 0) {
      strncpy(ext, DELEXT, strlen(ext));
      if (access(NewName, F_OK) == 0) {
         // the new name already exists, so let's remove that one first:
@@ -814,6 +839,10 @@
                        Add(r);
                        ChangeState();
                        Unlock();
+                       if (deleted) {
+                          r->fileSizeMB = DirSizeMB(buffer);
+                          r->deleted = time(NULL);
+                          }
                        }
                     else
                        delete r;
@@ -883,12 +912,33 @@
   LOCK_THREAD;
   cRecording *recording = GetByName(FileName);
   if (recording) {
-     Del(recording);
+     cThreadLock DeletedRecordingsLock(&DeletedRecordings);
+     Del(recording, false);
+     char *ext = strrchr(recording->FileName(), '.');
+     if (ext) {
+        strncpy(ext, DELEXT, strlen(ext));
+        recording->fileSizeMB = DirSizeMB(recording->FileName());
+        recording->deleted = time(NULL);
+        DeletedRecordings.Add(recording);
+        }
+     else
+        delete recording;
      ChangeState();
      TouchUpdate();
      }
 }
 
+int cRecordings::TotalFileSizeMB(void)
+{
+  int size = 0;
+  LOCK_THREAD;
+  for (cRecording *recording = First(); recording; recording = Next(recording)) {
+      if (recording->fileSizeMB > 0)
+         size += recording->fileSizeMB;
+      }
+  return size;
+}
+
 void cRecordings::ResetResume(const char *ResumeFileName)
 {
   LOCK_THREAD;
